;*********************************    
; Program : DA    
;           Dimension Aligned    
;           Jong-Suk Yi    
;           1995. 3. 9, 7/5    
;*********************************    
    
(defun C:DA(/    
th ds sp dsel sent pnt1 pnt2 ppnt    
ep ang1 w4 dp ang2 a2sgn tsgn fst dmdst    
dxy dst txt txt1 divl divn txtlen    
dtxt1 dtxt2 dtxt1p dtxt2p next sp1 ep1    
)    
    
  (defun SETERR(s)    
    (if (/= s "Function cancelled")    
        (princ (strcat "\nError: " s))    
    ); of If    
    (setq *error* oer seterr nil)    
    (princ)    
  ); of SETERR    
    
  (setq oer *error* *error* seterr)                     ;wAខ˥ a    
    
(setq th (getvar "DIMTXT")                              ; texta    
      dim_gap 10.0)                                    ; á eb    
    
(setq ds (getvar "DIMSCALE"))    
    
(push-env)    
    
(initget "Object")    
(setq sp (getpoint "\nPick first point/Object: "))    
(if (= sp "Object")    
  (progn    
    (setq dsel (entsel "\nSelect Dimension Entity: "))    
    (setq sent (entget (car dsel)))    
    (setq pnt1 (cdr (assoc 13 sent)))    
    (setq pnt2 (cdr (assoc 14 sent)))    
    (setq ppnt (cadr dsel))    
    (if (> (distance ppnt pnt1) (distance ppnt pnt2))    
      (setq sp pnt2) (setq sp pnt1))                        ;Ȃ aa     
  ) ;of progn THEN    
) ;of IF(sp=Object)    
    
(setq ep (getpoint sp "\nPick second point: "))    
(setq ang1 (angle sp ep))    
(setq w4 (which4 ang1))    
(cond                                       ;Baa b ( e)    
  ((or (= w4 1) (= w4 4)) (setq tang ang1))    
  ((or (= w4 2) (= w4 3)) (setq tang (- ang1 pi)))    
) ;of cond    
    
(setq dp (getpoint "\nPick Dimension line side: "))    
(setq ang2 (angle sp dp))    
(if (minusp (dang ang1 ang2)) (setq a2sgn -1) (setq a2sgn 1))  ;ѡq    
(setq tsgn 1)    
(if (and (or (= w4 2) (= w4 3)) (= a2sgn 1)) (setq tsgn -1))    
(if (and (or (= w4 1) (= w4 4)) (= a2sgn -1)) (setq tsgn -1))    
    
(setq fst (getint "\nDimension line Level <1>: "))       ;á AI b    
(if (= fst nil) (setq fst 1))    
(setq dmdst (* ds (+ 20 (* dim_gap (- fst 1)))))    
    
(while (/= ep nil)    
    
  (setq dxy (polar ep (+ (* pi 0.5 a2sgn) ang1) dmdst))    
  (setq dst (distance sp ep))    
    
  (if (< dst 1000.0)    
    (setq txt (rtos dst 2 0))                          ;1000e     
;    (setq txt (rtos (* dst 0.001) 2 3))                ;1000w     
    (setq txt (rtos_dimdsep (* dst 0.001)  3))                ;1000w     
    ) ;of if(dst < 1000)    
    
  (princ "\nDimension text <")                        ;Dimension texta    
  (princ txt)    
  (setq txt1 (getstring T ">: "))                     ; dimension textb    
  (if (= (substr txt1 1 1) "@")                                    ; b    
    (progn    
;      (setq divl (getreal "\nDivision length: "))       ;ae  b    
      (setq divl (atof (substr txt1 2 (1- (strlen txt1)))))    
      (setq divn (/ dst divl))    
      (setq divn (rtos divn 2 0))                       ;a e    
      (if (< divl 1000.)                                ;    
        (setq divl (rtos divl 2 0))    
;        (setq divl (rtos (* divl 0.001) 2 3))) ;of if    
        (setq divl (rtos_dimdsep (* divl 0.001) 3))) ;of if	    
      (setq txtlen (* (+ (strlen txt) (strlen divn) (strlen divl) 2) th ds    
                   (cdr (assoc 41 (tblsearch "STYLE" (getvar "TEXTSTYLE"))))))    
      (if (>= txtlen dst)    
        (progn    
          (setq dtxt1 (strcat divn "@" divl))    
          (setq dtxt2 (strcat "=" txt))    
          (setq dtxt1p (polar (mid-point sp ep)    
                              (+ ang1 (* pi 0.5 a2sgn))    
                              (+ dmdst (* th ds tsgn))))    
          (setq dtxt2p (polar (mid-point sp ep)    
                              (+ ang1 (* pi 0.5 a2sgn))    
                              (- dmdst (* th ds tsgn))))    
          (command "TEXT" "M" dtxt1p (* ds th) (rtod tang) dtxt1)    
          (command "TEXT" "M" dtxt2p (* ds th) (rtod tang) dtxt2)    
          (command "DIM1" "ALI" sp ep dxy " ")               ;DIMww     
        ) ;of progn THEN    
        (progn    
          (setq dtxt1 (strcat divn "@" divl "=" txt))    
          (command "DIM1" "ALI" sp ep dxy dtxt1)               ;DIMww     
        ) ;of progn ELSE    
      ) ;of IF    
    ) ;of progn THEN    
    (progn    
      (if (= txt1 "") (setq txt1 txt))                    ;巳b  texti q    
      (command "DIM1" "ALI" sp ep dxy txt1)               ;DIMww     
    ) ;of progn ELSE    
  ) ;of if(txt1=@)    
    
  (setq sp ep)                    ;{i a    
  (initget "eXit Undo")    
  (setq next (getdist "\nDistance or RETURN to Pick point/eXit: ")) ;{a ១    
  (cond                                               ;i baae 巳b    
    ((= next nil)    
      (setq ep (getpoint "\nPick point: "))                ;{i b    
      (setq sp1 (polar sp ang1 1.0))    
      (setq ep1 (polar ep (+ ang1 (* 0.5 pi)) 1.0))    
      (setq ep (inters sp sp1 ep ep1 nil))    
    ) ;cond(next=nil)    
    ((= next "eXit")                                         ;eXitb ep=nil    
      (setq ep nil)    
    ) ;cond(next="eXit")    
    ((numberp next)                                          ;dxa a w    
      (setq ep (polar sp ang1 next))    
    ) ;cond(next=number)    
  ) ;of cond    
    
) ;of while    
    
(pop-env)    
  (setq *error* oer seterr nil)    
(prin1)    
) ;defun    
    
;-------------------------------------------------------    
; function : rtos_dimdsep    
;            rtos (change . to dimdsep)    
;            Yi suk jong    
;            00/5/10    
;-------------------------------------------------------    
; argument    
;       real : real to be converted    
;  precision : decimail precision    
;-------------------------------------------------------    
(defun rtos_dimdsep(real precision / real precision txt txtlen count)      
  (setq txt (rtos real 2 precision)    
	txtlen (strlen txt)    
	count 1)      
      
  (while (and (/= (substr txt count 1) ".") (<= count (1+ txtlen)))    
    (setq count (1+ count))    
  );while    
  (if (> count txtlen)    
    txt    
    (strcat (substr txt 1 (1- count)) "," (substr txt (1+ count) (- txtlen count)))    
  )    
);defun        
