;*****************************************    
; Program : DC    
;           Dimension Circle    
;           By Jong-Suk Yi    
;           96/6/7    
;****************************************    
; ѡ i aЁa.    
;****************************************    
    
(defun C:DC(/    
ds elst cen rc sp sang ep eang seang    
cl txt dlst dcen rd dsp sep sgnpnt    
sgnr sgn dlevel mang dpnt wh4 tsgn    
tang txtpnt txtxy ltxt    
)    
    
  (defun SETERR(s)    
    (if (/= s "Function cancelled")    
        (princ (strcat "\nError: " s))    
    ); of If    
    (setq *error* oer seterr nil)    
    (princ)    
  ); of SETERR    
;  (setq oer *error* *error* seterr)    
    
  (push-env)                                                ;ŉwe ϡ    
    
  (setq dim_gap 10.0                            ;á巡 A ụ ១    
        ds (getvar "DIMSCALE")                                  ;aAt    
        th (getvar "DIMTXT"))                                                 ;texta    
    
  (setq elst (entget (car (entsel "\nSelect Arc or Circle: "))))  ; ѡ    
  (setq cen (cdr (assoc 10 elst))                               ;    
        rc  (cdr (assoc 40 elst)))                              ;eq    
    
  (setq dlst (entget (car (entsel "Select baseline circle: ")))) ;á  Arc    
  (setq dcen (cdr (assoc 10 dlst))                    ;á  Arc     
        rd   (cdr (assoc 40 dlst)))                   ;á  Arc eq    
    
  (setq sgnpnt (getpoint "\nPick Side: "))            ;á巁 á (,a?)    
  (setq sgnr (distance cen sgnpnt))                   ;á á ѡ    
  (if (> sgnr rd)    
    (setq sgn 1)    
    (setq sgn -1)    
  ) ;of if    
    
; á巁 á    
  (setq dlevel (getint "\nDim Line level <1>: "))    
  (if (= dlevel nil) (setq dlevel 1))    
    
  (setq sp (getpoint "Pick start point: "))                     ;b񷳝b    
  (setq sang (angle cen sp))                                    ; b e b    
    
  (setq next (getdist sp "\nDistance or RETURN to Pick point: ")) ;{a ១    
  (cond                                               ;i baae 巳b    
    ((= next nil)    
      (setq ep (getpoint "\nPick point: "))                     ;{i b    
      (setq epang (angle cen ep))                               ;{ b    
      (if (< epang sang) (setq lsgn 1) (setq lsgn -1))          ;á Зwз    
    ) ;cond(next=nil)    
    ((numberp next)                                             ;dxa a w    
       (setq ep (polar cen (- sang (/ next rc)) rc))             ;{    
       (if (> next 0) (setq lsgn 1) (setq lsgn -1))             ;á Зwз    
    ) ;cond(next=number)    
  ) ;of cond    
    
    
  (while (/= ep nil)    
    
    (setq eang (angle cen ep))                                    ; { e b 
    (setq seang (abs (dang sang eang)))                           ;bA { b    
    
    (setq cl (/ (* 2 pi rc seang) (* 2 pi)))                    ;Arc     
    (if (> cl 1000.0)    
;      (setq txt (rtos (* cl 0.001) 2 3))    
      (setq txt (rtos_dimdsep (* cl 0.001) 3))          
      (setq txt (rtos cl 2 0))    
    ) ;of if    
    
    (setq dsp (polar cen sang rd)                       ;á b    
          dep (polar cen eang rd))                      ;á {    
    
    (setq mang (/ (+ sang eang) 2.0))                   ;bb {b eb    
    (setq dpnt (polar cen mang (+ rd (* 20 ds sgn) (* (- dlevel 1) dim_gap ds sgn))))    
                                                            ;Dimension line á    
    
    (setq wh4 (which4 mang))    
    (if (or (= wh4 1) (= wh4 2))    
        (setq tsgn 1)    
        (setq tsgn -1)    
    ) ;of if    
    (setq tang (rtod (+ mang (* (/ PI 2.0) tsgn -1))))    
    (setq txtpnt (polar dpnt mang (* 1.1 th ds tsgn)))         ;textá (X,Y,Z)    
    (setq txtxy (list (car txtpnt) (cadr txtpnt)))          ;textá (X,Y)    
    (princ "\nText=<")    
    (princ txt)    
    (setq txt1 (getstring ">: "))    
    
  (if (= txt1 "@")    
    (progn    
      (setq divl (getint "\nDivision length: "))            ;ae  b    
      (setq divn (rtos (/ cl divl) 2 0))                    ;a e    
      (if (< divl 1000.)    
        (setq divl (rtos divl 2 0))                         ;1000e     
;        (setq divl (rtos (* 0.001 divl) 2 3))               ;1000w     
        (setq divl (rtos_dimdsep (* 0.001 divl) 3))               ;1000w     
	) ;of if    
      (setq txtlen (* (+ (strlen txt) (strlen divn) (strlen divl) 2) th ds  ;textA    
                   (cdr (assoc 41 (tblsearch "STYLE" (getvar "TEXTSTYLE"))))))    
      (if (>= txtlen cl)                       ;á A text eiae    
        (progn    
          (setq dtxt1 (strcat divn "@" divl))       ; a  aa()    
          (setq dtxt2 (strcat "=" txt))             ;                     ()    
          (setq dtxt1p (polar dpnt mang (* th ds tsgn)))    
          (setq dtxt2p (polar dpnt mang (* -1 th ds tsgn)))    
          (command "TEXT" "M" dtxt1p (* th ds) tang dtxt1)    
          (command "TEXT" "M" dtxt2p (* th ds) tang dtxt2)    
          (command "DIM1" "ANG" "" cen dsp dep "A" tang "T" " " dpnt txtxy)    
        ) ;of progn    
        (progn                                 ;á A text iae    
          (setq dtxt1 (strcat divn "@" divl "=" txt))    
          (command "DIM1" "ANG" "" cen dsp dep "A" tang "T" dtxt1 dpnt txtxy)    
        ) ;of progn ELSE    
      ) ;of IF    
    ) ;of progn THEN    
    (progn    
      (if (= txt1 "") (setq txt1 txt))                  ;巳b  texti q    
        (command "DIM1" "ANG" "" cen dsp dep "A" tang "T" txt1 dpnt txtxy)    
    ) ;of progn ELSE    
  ) ;of if(txt1=@)    
    
    (setq sp ep)                                            ;{i a    
    (setq sang (angle cen sp))                              ; b e b    
    
    (initget "eXit Undo")    
    (setq next (getdist "\nDistance or RETURN to Pick point/eXit: ")) ;{a ១    
    (cond                                                   ;i baae 巳b    
      ((= next nil)    
        (setq ep (getpoint "\nPick point: "))               ;{i b    
      ) ;cond(next=nil)    
      ((= next "eXit")                                      ;eXitb ep=nil    
        (setq ep nil)    
      ) ;cond(next="eXit")    
      ((numberp next)                                       ;dxa a w    
        (setq ep (polar cen (- sang (/ next rc lsgn)) rc))  ;{    
      ) ;cond(next=number)    
    ) ;of cond    
    
  ) ;of while    
    
  (pop-env)                                                 ;ŉwe     
  (setq *error* oer seterr nil)    
  (princ)    
    
) ;of defun    
    
    
;-------------------------------------------------------    
; function : rtos_dimdsep    
;            rtos (change . to dimdsep)    
;            Yi suk jong    
;            00/5/10    
;-------------------------------------------------------    
; argument    
;       real : real to be converted    
;  precision : decimail precision    
;-------------------------------------------------------    
(defun rtos_dimdsep(real precision / real precision txt txtlen count)      
  (setq txt (rtos real 2 precision)    
	txtlen (strlen txt)    
	count 1)      
      
  (while (and (/= (substr txt count 1) ".") (<= count (1+ txtlen)))    
    (setq count (1+ count))    
  );while    
  (if (> count txtlen)    
    txt    
    (strcat (substr txt 1 (1- count)) "," (substr txt (1+ count) (- txtlen count)))    
  )    
);defun        
