;*******************************************    
; Program : DO    
;           Dimension Oblique    
;           Jong-Suk Yi    
;           96/4/16    
;*******************************************    
; Vertical DIMi OBLIQUEaa.    
; A -  DIMAe ЁwEa.    
;          - OBLIQUEbe 30 Ёa a.    
;*******************************************    
    
(defun C:DO(/    
divl    divn    dp      ds      dsel    dtx     dtxt1   dtxt1p  dtxt2    
dtxt2p  dx      dxy     dy      ep      fst     lstdim  next    pnt1    
pnt2    ppnt    sent    sgn     sp      th      txt     txt1    txtlen    
)    
    
  (defun SETERR(s)    
    (if (/= s "Function cancelled")    
        (princ (strcat "\nError: " s))    
    ); of If    
    (setq *error* oer seterr nil)    
    (princ)    
  ); of SETERR    
  (setq oer *error* *error* seterr)    
    
  (setq th (getvar "DIMTXT")                          ;texta = dimtxt    
        dim_gap 10.0)                                 ;á eb    
  (setq ds (getvar "DIMSCALE"))                       ;scale factor    
    
  (push-env)                                          ;ŉwet ϡ    
    
  (initget "Object")    
  (setq sp (getpoint "\nPick first point/Object: "))  ; á q=Object    
  (if (= sp "Object")    
    (progn    
      (setq dsel (entsel "\nSelect Dimension Entity: "))   ; á Ȃ    
      (setq sent (entget (car dsel)))                      ;á entity    
      (setq pnt1 (cdr (assoc 13 sent)))                    ; b    
      (setq pnt2 (cdr (assoc 14 sent)))                    ; {    
      (setq ppnt (cadr dsel))                              ;Ȃ pick point    
      (if (> (distance ppnt pnt1) (distance ppnt pnt2))    ;pick pointA aa    
        (setq sp pnt2) (setq sp pnt1))                     ; i sp    
    ) ;of progn THEN    
  ) ;of IF(sp=Object)    
    
  (setq dp (getpoint "\nPick Dimension side: "))          ;á巡 ái wз    
    
  (setq dtx (- (car dp) (car sp)))    
  (setq sgn (/ dtx (abs dtx)))                            ;E e ѡ    
    
  (setq fst (getint "\nDimension line LEVEL <1>: "))      ;á levelb    
  (if (= fst nil) (setq fst 1))    
  (setq dx (* ds (+ 15 (* dim_gap (- fst 1)))))           ;e á巁១    
    
  (setq next (getdist sp "\nDistance or RETURN to Pick point: ")) ;{a ១    
  (cond                                                ;i baae 巳b    
    ((= next nil)    
      (setq ep (getpoint "\nPick point: "))               ;{i b    
      (setq ep (list (car sp) (cadr ep)))                 ;E {    
    ) ;cond(next=nil)    
    ((numberp next)                                       ;dxa a w    
      (setq ep (list (car sp) (+ (cadr sp) next)))        ;ep áe    
    ) ;cond(next=number)    
  ) ;of cond    
    
    
  (while (/= ep nil)                                  ;epa nil ae e    
    
    (setq dxy (list (+ (car ep) (* dx sgn)) (car ep) 0.0))  ;á巡  á    
    
    (setq dy (distance sp ep))                          ;  ១    
    (if (< dy 1000.0)    
      (setq txt (rtos dy 2 0))                          ;1000e     
;      (setq txt (rtos (* dy 0.001) 2 3))                ;1000w     
      (setq txt (rtos_dimdsep (* dy 0.001) 3))                ;1000      
    ) ;of if(dy < 1000)    
    
    (princ "\nDimension text <")                        ;Dimension texta    
    (princ txt)    
    (setq txt1 (getstring T ">: "))                     ; dimension textb    
    (if (= (substr txt1 1 1) "@")    
      (progn    
;        (setq divl (getint "\nDivision length: "))      ;ae  b    
        (setq divl (atof (substr txt1 2 (1- (strlen txt1)))))    
        (setq divn (rtos (/ dy divl) 2 0))              ;a e    
        (if (< divl 1000.)    
          (setq divl (rtos divl 2 0))                   ;ae a 1000e    
;          (setq divl (rtos (* divl 0.001) 2 3))) ;of if  ae a 1000w    
          (setq divl (rtos_dimdsep (* divl 0.001) 3))) ;of if  ae a 1000w    
	  (setq txtlen (* (+ (strlen txt) (strlen divn) (strlen divl) 2) th ds    
                     (cdr (assoc 41 (tblsearch "STYLE" (getvar "TEXTSTYLE"))))))    
        (if (>= txtlen dy)    
          (progn                                  ;texta  A eiae    
            (setq dtxt1 (strcat divn "@" divl))   ; a    
            (setq dtxt2 (strcat "=" txt))    
            (setq dtxt1p (mapcar '+ (mid-point sp ep)    
                                    (list (- (* dx sgn) (* ds th))  ;xá    
                                          (* dx (/ (sin (/ pi 6)) (cos (/ pi 6))))    
                                          0.0)))                     ;zá    
            (setq dtxt2p (mapcar '+ (mid-point sp ep)    
                                    (list (+ (* dx sgn) (* ds th))  ;xá    
                                          (* dx (/ (sin (/ pi 6)) (cos (/ pi 6))))    
                                          0.0)))                     ;zá    
            (command "TEXT" "M" dtxt1p (* th ds) "90" dtxt1)    
            (command "TEXT" "M" dtxt2p (* th ds) "90" dtxt2)    
            (command "DIM1" "VER" sp ep dxy " ")              ;DIMww     
          ) ;of progn THEN    
          (progn                                  ;texta  A iae    
            (setq dtxt1 (strcat divn "@" divl "=" txt))    
            (command "DIM1" "VER" sp ep dxy dtxt1)            ;DIMww     
          ) ;of progn ELSE    
        ) ;of IF    
      ) ;of progn THEN    
      (progn    
        (if (= txt1 "") (setq txt1 txt))                      ;巳b  texti q    
        (command "DIM1" "VER" sp ep dxy txt1)             ;DIMww     
      ) ;of progn ELSE    
    ) ;of if(txt1=@)    
    
    (setq lstdim (entlast))                               ;wq eiụ dimȂ    
    (setq oldexo (getvar "DIMEXO"))    
    (setvar "DIMEXO" 3)    
    (command "DIM1" "OBL" lstdim "" (* sgn 30))           ;30eq a    
    (command "DIM1" "UPDATE" lstdim "")    
    (setvar "DIMEXO" oldexo)    
    
    (setq sp ep)                    ;{i a    
    (initget "eXit Undo")    
    (setq next (getdist "\nDistance or RETURN to Pick point/eXit: ")) ;{a ១    
    (cond                                               ;i baae 巳b    
      ((= next nil)    
        (setq ep (getpoint "\nPick point: "))                 ;{i b    
        (setq ep (list (car sp) (cadr ep)))                   ;E {    
      ) ;cond(next=nil)    
      ((= next "eXit")                                        ;eXitb ep=nil    
        (setq ep nil)    
      ) ;cond(next="eXit")    
      ((numberp next)                                         ;dxa a w    
        (setq ep (list (car sp) (+ (cadr ep) next)))          ;ep áe    
      ) ;cond(next=number)    
    ) ;of cond    
    
  ) ;of while    
    
  (pop-env)    
  (setq *error* oer seterr nil)    
  (prin1)    
) ;defun    
    
    
;-------------------------------------------------------    
; function : rtos_dimdsep    
;            rtos (change . to dimdsep)    
;            Yi suk jong    
;            00/5/10    
;-------------------------------------------------------    
; argument    
;       real : real to be converted    
;  precision : decimail precision    
;-------------------------------------------------------    
(defun rtos_dimdsep(real precision / real precision txt txtlen count)      
  (setq txt (rtos real 2 precision)    
	txtlen (strlen txt)    
	count 1)      
      
  (while (and (/= (substr txt count 1) ".") (<= count (1+ txtlen)))    
    (setq count (1+ count))    
  );while    
  (if (> count txtlen)    
    txt    
    (strcat (substr txt 1 (1- count)) "," (substr txt (1+ count) (- txtlen count)))    
  )    
);defun        
