;*********************************        
; Program : DH        
;           Dimension Horizontal        
;           Jong-Suk Yi        
;           1995. 3. 7, 7/5        
;*********************************        
        
(defun C:DH(/        
th ds sp dsel sent pnt1 pnt2 ppnt                       ;be         
next ep dp dty sgn fst dy dxy dx        
txt txt1 divl divn txtlen dtxt1 dtxt2        
dtxt1p dtxt2p        
)        
        
  (defun SETERR(s)        
    (if (/= s "Function cancelled")        
        (princ (strcat "\nError: " s))        
    ); of If        
    (setq *error* oer seterr nil)        
    (princ)        
  ); of SETERR        
        
  (setq oer *error* *error* seterr)        
        
(setq th (getvar "DIMTXT")                               ;ia a         
      dim_gap 10.0)                                     ;á e a eb        
(setq ds (getvar "DIMSCALE"))                           ;scale factor        
        
(push-env)                                              ;ŉwt         
        
(initget "Object")        
(setq sp (getpoint "\nPick first point/Object: "))      ;b b        
(if (= sp "Object")                                       ; á q        
  (progn        
    (setq dsel (entsel "\nSelect Dimension Entity: "))    ;dimension entityȂ        
    (setq sent (entget (car dsel)))        
    (setq pnt1 (cdr (assoc 13 sent)))        
    (setq pnt2 (cdr (assoc 14 sent)))        
    (setq ppnt (cadr dsel))                                 ;Ȃ        
    (if (> (distance ppnt pnt1) (distance ppnt pnt2))        
      (setq sp pnt2) (setq sp pnt1))                         ;Ȃ aa         
  ) ;of progn THEN        
) ;of IF(sp=Object)        
        
(setq dp (getpoint "\nPick Dimension line side: ")) ;á巁 á(,a)        
(if (> (- (cadr dp) (cadr sp)) 0)        
  (setq sgn 1)        
  (setq sgn -1)        
) ;of if        
        
(setq fst (getint "\nLevel <1>: "))                  ;á eb        
(if (= fst nil) (setq fst 1))                       ;巳b 1e        
(setq dy (* ds (+ 20 (* dim_gap (- fst 1)))))             ;á á e        
        
(setq next (getdist sp "\nDistance or RETURN to Pick point: ")) ;{a ១        
(cond                                               ;i baae 巳b        
  ((= next nil)        
    (setq ep (getpoint "\nPick point: "))                ;{i b        
    (setq ep (list (car ep) (cadr sp)))                  ;E {        
  ) ;cond(next=nil)        
  ((numberp next)                                          ;dxa a w        
    (setq ep (list (+ (car sp) next) (cadr sp)))             ;ep áe        
    (if (> next 0) (setq lsgn 1) (setq lsgn -1))           ;á Зwз        
  ) ;cond(next=number)        
) ;of cond        
        
        
(while (/= ep nil)                                  ;epa nil ae  e        
        
  (setq dxy (list (car ep) (+ (cadr ep) (* dy sgn)) 0.0))  ;á á        
        
  (setq dx (distance sp ep))                          ;១ e        
  (if (< dx 1000.0)        
    (setq txt (rtos dx 2 0))                          ;1000e         
;    (setq txt (rtos (* dx 0.001) 2 3))                ;1000w         
    (setq txt (rtos_dimdsep (* dx 0.001) 3))                ;1000w         
  ) ;of if(dx < 1000)        
        
  (princ "\nDimension text <")                        ;Dimension texta        
  (princ txt)        
  (setq txt1 (getstring T ">: "))                     ; dimension textb        
  (if (= (substr txt1 1 1) "@")        
    (progn        
;      (setq divl (getint "\nDivision length: "))      ;ae  b        
      (setq divl (atof (substr txt1 2 (1- (strlen txt1)))))        
      (setq divn (rtos (/ dx divl) 2 0))              ;a e        
      (if (< divl 1000.)        
        (setq divl (rtos divl 2 0))                   ;1000e         
        (setq divl (rtos_dimdsep (* 0.001 divl)  3))) ;of if ;1000w         
      (setq txtlen (* (+ (strlen txt) (strlen divn) (strlen divl) 2) th ds  ;textA        
                   (cdr (assoc 41 (tblsearch "STYLE" (getvar "TEXTSTYLE"))))))        
      (if (>= txtlen dx)                       ;á A text eiae        
        (progn        
          (setq dtxt1 (strcat divn "@" divl))       ; a  aa        
          (setq dtxt2 (strcat "=" txt))        
          (setq dtxt1p (mapcar '+ (mid-point sp ep)        
                                  (list 0.0 (+ (* dy sgn) (* ds th)) 0.0)))        
          (setq dtxt2p (mapcar '+ (mid-point sp ep)        
                                  (list 0.0 (- (* dy sgn) (* ds th)) 0.0)))        
          (command "TEXT" "M" dtxt1p (* th ds) "0" dtxt1)        
          (command "TEXT" "M" dtxt2p (* th ds) "0" dtxt2)        
          (command "DIM1" "HOR" sp ep dxy " ")               ;DIMww         
        ) ;of progn THEN        
        (progn                                 ;á A text iae        
          (setq dtxt1 (strcat divn "@" divl "=" txt))        
          (command "DIM1" "HOR" sp ep dxy dtxt1)               ;DIMww         
        ) ;of progn ELSE        
      ) ;of IF        
    ) ;of progn THEN        
    (progn        
      (if (= txt1 "") (setq txt1 txt))                  ;巳b  texti q        
      (command "DIM1" "HOR" sp ep dxy txt1)             ;DIMww         
    ) ;of progn ELSE        
  ) ;of if(txt1=@)        
        
  (setq sp ep)                                          ;{i a        
  (initget "eXit Undo")        
  (setq next (getdist "\nDistance or RETURN to Pick point/eXit: ")) ;{a ១        
  (cond                                               ;i baae 巳b        
    ((= next nil)        
      (setq ep (getpoint "\nPick point: "))                ;{i b        
      (setq ep (list (car ep) (cadr sp)))                  ;E {        
    ) ;cond(next=nil)        
    ((= next "eXit")                                       ;eXitb ep=nil        
      (setq ep nil)        
    ) ;cond(next="eXit")        
    ((numberp next)                                             ;dxa a w        
      (setq ep (list (+ (car sp) (* next lsgn)) (cadr sp)))     ;ep áe        
    ) ;cond(next=number)        
  ) ;of cond        
        
) ;of while        
        
  (pop-env)        
  (setq *error* oer seterr nil)        
  (prin1)        
) ;defun        
      
;-------------------------------------------------------    
; function : rtos_dimdsep    
;            rtos (change . to dimdsep)    
;            Yi suk jong    
;            00/5/10    
;-------------------------------------------------------    
; argument    
;       real : real to be converted    
;  precision : decimail precision    
;-------------------------------------------------------    
(defun rtos_dimdsep(real precision / real precision txt txtlen count)      
  (setq txt (rtos real 2 precision)    
	txtlen (strlen txt)    
	count 1)      
      
  (while (and (/= (substr txt count 1) ".") (<= count (1+ txtlen)))    
    (setq count (1+ count))    
  );while    
  (if (> count txtlen)    
    txt    
    (strcat (substr txt 1 (1- count)) "," (substr txt (1+ count) (- txtlen count)))    
  )    
);defun        
